package utils;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

/**
 * TICa Clase analizador sintáctico
 * 
 * @author jwdd
 * @version 1
 * @since 14/02/11
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 */
public class ASyntax
{
	/**
	 * Busca en la BD de pictogramas y devuelve un ResultSet con los resultados
	 * 
	 * @param search
	 *            cadena a buscar en la BD
	 * @param type
	 *            Entero 1- Que contengan la palabra 2- La palabra en si
	 * @return ResultSet con los resultados
	 * @throws SQLException
	 * @throws ClassNotFoundException
	 * @throws Exception
	 */
	private ArrayList<String[]> livePict = new ArrayList<String[]>();

	public static ResultSet getPict(String search, int type)
	{
		Statement stat = null;
		ResultSet rs = null;
		String simb = "1234567890¿?¡!";
		String sql = null;
		String search2 = "";

		search = search.toLowerCase();
		String tabla = search.substring(0, 1); // Primer caracter
		search2 = search.substring(0, 1).toUpperCase() + search.substring(1); // Igual que la cadena search pero con la primera letra en mayusculas

		tabla = tabla.toLowerCase();
		tabla = NotAccent(tabla);

		if(simb.indexOf(tabla) != -1) tabla = "noletter"; // Si la palabra
		// empieza por un
		// signo o un número

		switch (type)
		{
			case 1: // arbol*
				sql = "SELECT * FROM " + tabla + " WHERE " + tabla + ".STATEPIC='A' AND (" + tabla + ".TEXTPIC LIKE '" + search + "%' OR " + tabla + ".TEXTPIC LIKE '" + search2 + "%')";
				break;
			case 2: // *arbol
				sql = "SELECT * FROM " + tabla + " WHERE " + tabla + ".STATEPIC='A' AND (" + tabla + ".TEXTPIC LIKE '%" + search + "' OR " + tabla + ".TEXTPIC LIKE '%" + search2 + "')";
				break;
			case 3: // *arbol*
				sql = "SELECT * FROM " + tabla + " WHERE " + tabla + ".STATEPIC='A' AND (" + tabla + ".TEXTPIC LIKE '%" + search + "%' OR " + tabla + ".TEXTPIC LIKE '%" + search2 + "%')";
				break;
			case 4: // arbol
				sql = "SELECT * FROM " + tabla + " WHERE " + tabla + ".STATEPIC='A' AND (" + tabla + ".TEXTPIC ='" + search + "' OR " + tabla + ".TEXTPIC ='" + search2 + "')";
				break;
		}

		try
		{
			stat = Global.DB_HANDLER.getStatement();
			rs = stat.executeQuery(sql);
		}
		catch (SQLException e)
		{
			System.out.println("error");
			// e.printStackTrace();
		}

		return rs;
	}

	/**
	 * Elimina los acentos de una cadena
	 * 
	 * @param str
	 *            La cadena a la que queremos eliminar los acentos.
	 * @return La cadena sin acentos
	 */
	private static String NotAccent(String str)
	{
		// Cadena de caracteres original a sustituir.
		String original = "áàäâéèëêíìïóòöôúùuñÁÀÄÉÈËÍÌÏÓÒÖÚÙÜÑçÇ";
		// Cadena de caracteres ASCII que reemplazarán los originales.
		String ascii = "aaaaeeeeiiioooouuunAAAEEEIIIOOOUUUNcC";
		String output = str;

		for (int i = 0; i < original.length(); i++)
		{
			// Reemplazamos los caracteres especiales.
			output = output.replace(original.charAt(i), ascii.charAt(i));
		}

		return output;
	}

	/**
	 * Elimina X elementos de la conversación
	 * 
	 * @param lastwords
	 *            Número de palabras a eliminar del documento
	 */
	public void DeleteWordRipperLive(int lastwords)
	{
		for (int i = 0; i < lastwords; i++)
		{
			livePict.remove(livePict.size() - 1);
		}
	}

	/**
	 * Añade una palabra a la conversación y devuelve el número de elementos que hay que eliminar
	 * 
	 * @param str
	 * @return
	 */
	public String[] AddWordTextRipperLive(String str)
	{
		ArrayList<String[]> tmp = new ArrayList<String[]>();
		ResultSet rs = null;
		boolean sip = false;
		int bultimo = 0; // Por si tengo que borrar el último elemento

		String[] resultado = new String[2];

		String[] mstring = null;
		str.replaceAll("\\.", " "); // El . es un caracter especial
		str.replaceAll(",", " ");
		str.replaceAll(";", " ");
		str.replaceAll("!", " ");
		str.replaceAll("¡", " ");
		str.replaceAll("¿", " ");
		// str.replaceAll("?", " ");

		mstring = str.split(" ");

		try
		{
			String palabra = str;

			sip = false;
			tmp.clear();
			if(livePict.size() >= 2)
			{
				String p3 = livePict.get(livePict.size() - 2)[1] + " " + livePict.get(livePict.size() - 1)[1] + " " + palabra;
				rs = ASyntax.getPict(p3, 4);
				if(rs.next())
				{
					String[] t = new String[2];
					t[0] = rs.getString("IMG_ID");
					t[1] = p3;

					tmp.add(t);
					sip = true;
					bultimo = 2;
				}
			}

			if(livePict.size() >= 1)
			{
				String p2 = livePict.get(livePict.size() - 1)[1] + " " + palabra;
				rs = ASyntax.getPict(p2, 4);
				if(rs.next() && !sip)
				{
					String[] t = new String[2];
					t[0] = rs.getString("IMG_ID");
					t[1] = p2;
					tmp.add(t);
					sip = true;
					bultimo = 1;
				}
			}

			rs = ASyntax.getPict(palabra, 4);
			if(rs.next() && !sip)
			{
				String[] t = new String[2];
				t[0] = rs.getString("IMG_ID");
				t[1] = palabra;
				tmp.add(t);
			}

			//Statement temp = rs.getStatement();
			//Connection temp2 = temp.getConnection();
			rs.close();
			//temp.close();
			//temp2.close();

			if(bultimo == 2)
			{
				livePict.remove(livePict.size() - 1);
				livePict.remove(livePict.size() - 1); // Borra los dos
				// últimos elementos
			}

			if(bultimo == 1)
			{
				livePict.remove(livePict.size() - 1); // Borra el último
				// elemento
			}

			if(tmp.size() > 0)
			{
				livePict.add(tmp.get(0));

				resultado[0] = String.valueOf(bultimo);
				resultado[1] = tmp.get(0)[0];

				return resultado;
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		return null;
	}

	public static String[] TextRipper(String str)
	{
		ArrayList<String> resultado = new ArrayList<String>();
		ArrayList<String> tmp = new ArrayList<String>();
		ResultSet rs = null;
		boolean sip = false;
		boolean bultimo1 = false; // Por si tengo que borrar el último elemento
		boolean bultimo2 = false;
		String[] resultado2 = null;

		String[] mstring = null;
		str.replaceAll("\\.", " "); // El . es un caracter especial
		str.replaceAll(",", " ");
		str.replaceAll(";", " ");
		str.replaceAll("!", " ");
		str.replaceAll("¡", " ");
		str.replaceAll("¿", " ");
		// str.replaceAll("?", " ");

		mstring = str.split(" ");

		for (int i = 0; i < mstring.length; i++)
		{
			try
			{
				String palabra = mstring[i].trim();

				if(i > 1)
				{
					bultimo1 = false;
					bultimo2 = false;
					sip = false;
					tmp.clear();
					String p3 = mstring[i - 2].trim() + " " + mstring[i - 1] + " " + palabra;
					String p2 = mstring[i - 1] + " " + palabra;
					rs = ASyntax.getPict(p3, 4);
					if(rs.next())
					{
						tmp.add(rs.getString("IMG_ID"));
						sip = true;
						bultimo2 = true;
					}
					rs = ASyntax.getPict(p2, 4);
					if(rs.next() && !sip)
					{
						tmp.add(rs.getString("IMG_ID"));
						sip = true;
						bultimo1 = true;
					}
					rs = ASyntax.getPict(palabra, 4);
					if(rs.next() && !sip)
					{
						tmp.add(rs.getString("IMG_ID"));
					}
				}
				else if(i == 1)
				{
					bultimo1 = false;
					sip = false;
					tmp.clear();
					String p2 = mstring[i - 1] + " " + palabra;
					rs = ASyntax.getPict(p2, 4);
					if(rs.next() && !sip)
					{
						tmp.add(rs.getString("IMG_ID"));
						sip = true;
						bultimo1 = true;
					}
					rs = ASyntax.getPict(palabra, 4);
					if(rs.next() && !sip)
					{
						tmp.add(rs.getString("IMG_ID"));
					}
				}
				else if(i == 0)
				{
					tmp.clear();
					rs = ASyntax.getPict(palabra, 4);
					if(rs.next())
					{
						tmp.add(rs.getString("IMG_ID"));
					}
				}

				//Statement temp = rs.getStatement();
				//Connection temp2 = temp.getConnection();
				rs.close();
				//temp.close();
				//temp2.close();

				if(bultimo2)
				{
					resultado.remove(resultado.size() - 1);
					resultado.remove(resultado.size() - 1); // Borra los dos
					// últimos elementos
				}

				if(bultimo1)
				{
					resultado.remove(resultado.size() - 1); // Borra el último
					// elemento
				}

				if(tmp.size() > 0)
				{
					resultado.add(tmp.get(0));
				}
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}

		int n = resultado.size();
		if(n > 0)
		{
			resultado2 = new String[n];
			for (int i = 0; i < n; i++)
			{
				resultado2[i] = resultado.get(i);
			}
			return resultado2;
		}

		return null;
	}

	public static void main(String args[])
	{
		String[] temporal = new String[2];
		String[] cadena = ASyntax.TextRipper("Director");

		for (int i = 0; i < cadena.length; i++)
		{
			System.out.println(cadena[i]);
		}
		System.out.println("*****************************************************");

		ASyntax as = new ASyntax();

		temporal = as.AddWordTextRipperLive("Director");
		System.out.println(temporal[0] + " " + temporal[1]);
		temporal = as.AddWordTextRipperLive("de");
		System.out.println(temporal[0] + " " + temporal[1]);
		temporal = as.AddWordTextRipperLive("orquesta");
		System.out.println(temporal[0] + " " + temporal[1]);
		temporal = as.AddWordTextRipperLive("sda");
		if(temporal != null)
		{
			System.out.println(temporal[0] + " " + temporal[1]);
		}
		temporal = as.AddWordTextRipperLive("xxx3o");
		if(temporal != null)
		{
			System.out.println(temporal[0] + " " + temporal[1]);
		}
	}
}
