package utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

/**
 * The following piece of source code is an extension of that posted at
 * http://www.mkyong.com/java/how-to-decompress-files-from-a-zip-file/
 * @author jwdd
 */
public class UnZip
{
	List<String> fileList;
	private static final String INPUT_ZIP_FILE = File.separator + "tmp" + File.separator + "cosa.zip";
	private static final String OUTPUT_FOLDER = "/tmp/carpeta";

	/**
	 * Unzip it 
	 * @param zipFile input zip file
	 * @param output zip file output folder
	 */
	public static void unZipIt(String zipFile, String outputFolder)
	{

		byte[] buffer = new byte[1024];

		try
		{
			// create output directory is not exists
			File folder = new File(outputFolder);
			if(!folder.exists())
			{
				folder.mkdir();
			}

			// get the zip file content
			ZipInputStream zis = new ZipInputStream(new FileInputStream(zipFile));
			// get the zipped file list entry
			ZipEntry ze = zis.getNextEntry();

			while (ze != null)
			{

				String fileName = ze.getName();

				String[] ruta = fileName.split("\\" + File.separator);

				if(ruta.length > 1) // No me esta creando los directorios y subdirectorios con esto lo soluciono
				{
					String direct = outputFolder;
					for (int i = 0; i < ruta.length - 1; i++)
					{
						direct += File.separator + ruta[i];
					}
					new File(direct).mkdirs();
				}

				if(ze.isDirectory())
				{
					new File(outputFolder + File.separator + fileName).mkdirs();
				}
				else
				{
					File newFile = new File(outputFolder + File.separator + fileName);
					// System.out.println("file unzip : " + newFile.getAbsoluteFile());

					// create all non exists folders
					// else you will hit FileNotFoundException for compressed
					// folder

					FileOutputStream fos = new FileOutputStream(newFile);

					int len;
					while ((len = zis.read(buffer)) > 0)
					{
						fos.write(buffer, 0, len);
					}

					fos.close();
				}
				ze = zis.getNextEntry();
			}

			zis.closeEntry();
			zis.close();
		}
		catch (IOException ex)
		{
			ex.printStackTrace();
		}
	}

	public static void main(String[] args)
	{
		UnZip unZip = new UnZip();
		UnZip.unZipIt(INPUT_ZIP_FILE, OUTPUT_FOLDER);
	}
}
