
/*
 * TecladoVirtual2.java
 *
 * Created on 27-abr-2011, 
 */
package virtual;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.filechooser.FileSystemView;

import utils.Global;
import utils.XMLBotones;
import editor.Credits;


/**
 *
 * @author njerez
 */
@SuppressWarnings("serial")
public class TecladoVirtual2 extends javax.swing.JFrame implements MouseListener, MouseMotionListener, WindowListener {
//public class TecladoVirtual2 extends tecladovirtual1.TecladoVirtual1 implements MouseListener, MouseMotionListener, WindowListener {
 	
    /** Creates new form TecladoVirtual1 */
    public TecladoVirtual2() {
    	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        initComponentsDef();	

    }
    /** Sobrecarga del constructor para pasar el jFrame Padre */
    public TecladoVirtual2(JFrame jMiFrame) {
    	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        initComponentsDef();	
        jFramePadre = jMiFrame;
    }
    
    public TecladoVirtual2(String sFichero, int iwidth, int iheight, int iIdUsr) {
    	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    	initComponentsDef(iwidth, iheight);
    	AbrirTeclado(sFichero);
    	RedimensionTeclado (jPanel1.getSize().width, jPanel1.getSize().height);
    }

    private void RedimensionTeclado (int iwidth, int iheight){

    	double iBW,iBH,iW,iH, iScalaW=(double)iwidth/(double)iJP1Width, iScalaH =(double)iheight/(double)iJP1Height;
    	
   		for(int i=0; i<aBotones.length; i++) { 
   			iBW = (double) aBotones[i].getBounds().x * iScalaW;
       		iBH = (double) aBotones[i].getBounds().y * iScalaH;
       		iW = (double) aBotones[i].getSize().width * iScalaW;
       		iH = (double) aBotones[i].getSize().height * iScalaH;

       			aBotones[i].setBounds((int)iBW,(int)iBH ,(int) iW, (int) iH);
       			
       			if (aBotones[i].getName() != null){  
       			// y si existe pictograma seleccionado
       	            String ruta = Global.PICT_FOLDER + Global.SEPARADOR_SYS;
       	            ruta = ruta.concat(aBotones[i].getName());
       	            ruta = ruta.concat(Global.PICT_EXT_PUNTO);
       	            ImageIcon iPicto = new ImageIcon(ruta);
       	            Image img = iPicto.getImage();               
       	            Image newimg = img.getScaledInstance((int)iW, (int)iH, java.awt.Image.SCALE_SMOOTH); 
       	            ImageIcon newIcon = new ImageIcon(newimg);
       	            aBotones[i].setIcon(newIcon);     	           
       	        	}
              	aBotones[i].repaint();
           }
   		    repaint();
	
    }
    
 /****
     *  FUNCION initComponentsDef 
     *  Inicializa la interfaz: frame principal, men�, panel con cuadrícula, 
     *  y configurador. Además inicializa las variables iContador que lleva la 
     *  cuenta del número de teclas en el teclado.
     *  @author njerez
     *  *************************************************************************/
    private void initComponentsDef() {
    	setPrincipal();     	// Inicia frame principal     
    	setMenuBarra (); 		// Crea menú de barra con menu "Archivo" y menu Correccion.
        setjPanels(); 			// Crea Panel con cuadricula  y Panel de Correccion   
        setConfigurador(); 		// Crea ventana de configuracion  
        iContador = 0;  
        try {
			setIconImage (ImageIO.read (new File (Global.FAVICON_TV)));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println ("No se puede abrir icono.");
			e.printStackTrace();
		}
    } 
    
    private void initComponentsDef(int iw, int ih) {
    	setPrincipal(iw, ih);     	// Inicia frame principal     
    	setMenuBarra (); 			// Crea menú de barra con menu "Archivo" y menu Correccion.
    	setjPanel1(iw, ih); 		// Crea Panel con cuadricula  y Panel de Correccion   
        setConfigurador(); 			// Crea ventana de configuracion  
        iContador = 0;    
        sArchivo = "nuevo.xml";
        try {
			setIconImage (ImageIO.read (new File (Global.FAVICON_TV)));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			System.out.println ("No se puede abrir icono.");
			e.printStackTrace();
		}
    } 
    
    /****
     *  FUNCION setPrincipal 
     *  Inicia frame principal - TecladoVirtual1, con el tamño de la pantalla.
     *  Impide el cambio de tamaño de la ventana.
     *  @author njerez
     *  *************************************************************************/
    private void setPrincipal () {
    	setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    	setMinimumSize(new Dimension(java.awt.Toolkit.getDefaultToolkit().getScreenSize().width-10,java.awt.Toolkit.getDefaultToolkit().getScreenSize().height-50));
    	setTitle(Global.LANG.getString("titulo2"));
    	setVisible(true);
        setResizable(false);
    }
    
    private void setPrincipal (int iw, int ih) {
    	setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    	setTitle(Global.LANG.getString("titulo2"));
    	setPreferredSize(new Dimension(iw,ih));
    	pack();
    	dispose();
    }
    
    /****
     *  FUNCION setConfigurador
     *  Inicializa la interfaz de la ventana de configuracion para cada tecla.
     *  @author njerez
     *  *************************************************************************/
    private void setConfigurador (){
    	 ventana = new NuevoBoton (Global.LANG.getString("configurador"), this); 
    	 ventana.initComponents();
         ventana.getWindow().addWindowListener(this);
    }
    
    
    /****
     *  FUNCION setMenuBarra
     *  Crea y agrega la barra de menu superior: Menu 'Archivo'.
     *  ActionListener para Abrir, Guardar y Nuevo.
     *  @author njerez
     *  *************************************************************************/ 
    private void setMenuBarra (){
    	setJMenuCorreccion();
    	jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenu1.setText(Global.LANG.getString("archivo"));
        ImageIcon iColor2 = new ImageIcon("img/archivo.png");   
        jMenu1.setIcon(iColor2);
        jMenu1.setFont(Global.INTERFACE_FONT);
        jMenuItem1 = new javax.swing.JMenuItem(); // abrir
        jMenuItem2 = new javax.swing.JMenuItem(); // nuevo
        jMenuItem3 = new javax.swing.JMenuItem(); // guardar
        jMenuItem4 = new javax.swing.JMenuItem(); // volver
        jMenuItem5 = new javax.swing.JMenuItem(); // acerca de

        
        jMenuItem1.setFont(Global.INTERFACE_FONT);
        jMenuItem1.setText(Global.LANG.getString("abrir"));
        ImageIcon iColor = new ImageIcon("img/archivo.png");   
        jMenuItem1.setIcon(iColor);
        jMenuItem1.addActionListener( new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                    	AbrirTeclado();
           }
       });

        jMenuItem2.setFont(Global.INTERFACE_FONT); 
        jMenuItem2.setText(Global.LANG.getString("nuevo"));
        iColor = new ImageIcon("img/hoja.png");    
        jMenuItem2.setIcon(iColor);
        jMenuItem2.addActionListener( new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	NuevoTeclado();
           }
       });
       
        jMenuItem3.setFont(Global.INTERFACE_FONT); 
        jMenuItem3.setText(Global.LANG.getString("guardarcomo"));
        iColor = new ImageIcon("img/guardarcomo.png");    
        jMenuItem3.setIcon(iColor);
        jMenuItem3.addActionListener( new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	GuardarTeclado();
            }
        });
        jMenuItem3.setEnabled(false); //hasta que no haya al menos un botón no se habilita
        
        jMenuItem4.setFont(Global.INTERFACE_FONT); // NOI18N
        jMenuItem4.setText(Global.LANG.getString("volver"));
        iColor = new ImageIcon("img/back.png");    
        jMenuItem4.setIcon(iColor);
        jMenuItem4.addActionListener( new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	setVisible(false);
            	jFramePadre.setVisible(true);	
            }
        });
        
        jMenuItem5.setFont(Global.INTERFACE_FONT);
        jMenuItem5.setText(Global.LANG.getString("acercade"));
        iColor = new ImageIcon("img/info.png");   
        jMenuItem5.setIcon(iColor);
        jMenuItem5.addActionListener( new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	acerca.display();
           }
       });
        
        jMenu1.add(jMenuItem1); 
        jMenu1.add(jMenuItem2);
        jMenu1.add(jMenuItem3);
        jMenu1.add(jMenuItem4);
        jMenu1.add(jMenuItem5);
       // jMenuBar1.setBackground(new Color(129,190,247)); //  nuevo diseño
        
        jMenu1.setBorder(BorderFactory.createEmptyBorder(7, 10, 7, 10));
        jMenuC.setBorder(BorderFactory.createEmptyBorder(7, 10,7, 10));
        jMenuBar1.add(jMenu1);
        jMenuBar1.add(jMenuC);
        
        
        // PAra el título
        jMenu2 = new javax.swing.JMenu();
        jMenu2.setMargin(new Insets (0,50,0,0));
        jMenu2.setText(Global.LANG.getString("nuevotcv"));
        sArchivo = "nuevo.xml";
        jMenu2.setEnabled(false);
        jMenuBar1.add(jMenu2);
        
        setJMenuBar(jMenuBar1);
    }
    
    
     	
    	 
    
    /****
     *  FUNCI�N setJMenuCorreccion
     *  Crea y agrega la barra de men� superior: Men� 'Correccion'.
     *  ActionListener Ver, Grabar.
     *  @author njerez
     *  *************************************************************************/ 
    private void setJMenuCorreccion (){
    	//jMenuBarC = new javax.swing.JMenuBar();
        jMenuC = new javax.swing.JMenu();
        jMenuC.setText(Global.LANG.getString("correc"));
        ImageIcon iColor2 = new ImageIcon("img/correccion.png");   
        jMenuC.setIcon(iColor2);
        jMenuC.setFont(Global.INTERFACE_FONT);
        jMenuItem1C = new javax.swing.JMenuItem();
        jMenuItem2C = new javax.swing.JMenuItem();
        jMenuItem1C.setFont(Global.INTERFACE_FONT);
        jMenuItem1C.setText(Global.LANG.getString("versec"));
        ImageIcon iColor = new ImageIcon("img/lupa.png");   
        jMenuItem1C.setIcon(iColor);
        jMenuItem1C.addActionListener( new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                    	mostrarSecuencia();
           }
       });

        jMenuItem2C.setFont(Global.INTERFACE_FONT); 
        jMenuItem2C.setText(Global.LANG.getString("grabar"));
        iColor = new ImageIcon("img/play.png");   
        jMenuItem2C.setIcon(iColor);
        jMenuItem2C.addActionListener( new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            		grabarSecuencia();
           }
       });

        jMenuC.add(jMenuItem1C); 
        jMenuC.add(jMenuItem2C); 
    }
    
    /****
     *  FUNCI�N mostrarSecuencia
     *  Muestra la secuencia.
     *  @author njerez
     *  *************************************************************************/ 
    private void mostrarSecuencia(){
    	jlabel2.setVisible(false);
    	jlabel1.setVisible(false);
    	if (bBotonesIniciado){
    		sSecuencia = new String[aBotones.length];
    		for (int i=0; i<aBotones.length; i++){
    			if (aBotones[i].getMnemonic() >= 0){
    				sSecuencia[aBotones[i].getMnemonic()] = aBotones[i].getToolTipText();
    			}
    		}
    	   	sSec = Global.LANG.getString("pararedaccion");
    	   	for (int i=0; i<aBotones.length; i++){
    	   		if (sSecuencia[i] !=null)
    	   			sSec = sSec+(sSecuencia[i]+" , ");
    	   	}
    	   	jlabelsec.setText(sSec );
    	   	jlabelsec.setFont(Global.INTERFACE_FONT);
    	   	jlabelsec.setVisible(true);
    	   	jlabelsec.repaint();
    	   	jPanelC.revalidate();
    	   	jPanel1.revalidate();
    	   	repaint();
    	}
    }
    
    /****
     *  FUNCI�N grabarSecuencia
     *  Graba la secuencia de correccion del teclado.
     *  @author njerez
     *  *************************************************************************/ 
    private void grabarSecuencia(){
    	jMenu1.setEnabled(false); // deshabilita menus de la barra
    	jMenuC.setEnabled(false); // deshabilita menus de la barra
    	isRecording = true; 
    	if (bBotonesIniciado){ 	  // si hay botones
    		for (int i=0; i<aBotones.length; i++){
    			aBotones[i].setMnemonic(-1); 
    		}
    	}
    	ordenSecuencia=0; 
    	jButton1.setVisible(false); // oculta boton de tecla
    	jlabel1.setVisible(false);  // oculta ver-secuencia
    	jlabel2.setVisible(true);   // muestra grabar-secuencia
    	jButtonC.setVisible(true);  // muestra bot�n de grabado.
    	jPanelC.revalidate();
    	jPanel1.revalidate();
    	repaint();
    }
    
    /****
     *  FUNCION setjPanels
     *  Crea y agrega el jPanel1 con la cuadr�cula y el boton padre "TECLA".
     *  Crea tambien el jPanel de Correcci�n. Y los a�ade.
     *  @author njerez
     *  *************************************************************************/ 
   private void setjPanels (){
	   
	   jPanel1 = new JPanelCuadricula();  
       
       // jBImagen - Botón que contiene la imagén a describir.
       jBImagen = new JButton (Global.LANG.getString("imgdesc"));
       jBImagen.setFont(Global.INTERFACE_FONT);
       jBImagen.setBackground(new Color (251,245,239));//(251,251,239));//Color.white);
       jBImagen.setFocusable(false);
       jBImagen.addActionListener(new java.awt.event.ActionListener() {
           public void actionPerformed(java.awt.event.ActionEvent evt) {
        	   //Ventana de selección de ficheros con filtrado por extensión
        	   FileNameExtensionFilter filtro = new FileNameExtensionFilter (Global.LANG.getString("nombreFiltro"), "png", "jpg", "gif");
       			fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
       			fileChooser.setFileFilter(filtro);
        	   
        	   fileChooser.setCurrentDirectory(new File (Global.TCV2_IMG_FOLDER));
        	   int seleccion = fileChooser.showOpenDialog(rootPane);
        	   if (seleccion == JFileChooser.APPROVE_OPTION){

        		   if ((!fileChooser.getSelectedFile().getParent().equals(Global.INSTALL_FOLDER+Global.SEPARADOR_SYS+Global.TCV2_IMG_FOLDER)))
        		   {// si la imagen no está en la carpeta adecuada tcv2/img, entonces se copia
        			 
        			    try {
        			    	FileInputStream fis = new FileInputStream(fileChooser.getSelectedFile().getPath()); //inFile -> Archivo a copiar
        			    	FileOutputStream fos = new FileOutputStream(Global.TCV2_IMG_FOLDER+Global.SEPARADOR_SYS+fileChooser.getSelectedFile().getName()); //outFile -> Copia del archivo
        			    	FileChannel inChannel = fis.getChannel();
        			    	FileChannel outChannel = fos.getChannel();
        			    	inChannel.transferTo(0, inChannel.size(), outChannel);
        			    	fis.close();
        			    	fos.close();
        			    }
        			    catch (IOException ioe) {
        			    	System.err.println(Global.LANG.getString("errorcopia"));
        			   }
        		   } // if - si la imagen no está en la carpeta adecuada de los tcv2
        		 
        		   sRutaImagen = fileChooser.getSelectedFile().getName();
        		   MuestraImagenDesc (Global.TCV2_IMG_FOLDER+Global.SEPARADOR_SYS+fileChooser.getSelectedFile().getName());
        	   }
           }
       	});
       
       // jButton1 - Botón TECLA. el botón padre a partir del cual se crea el resto de botones/teclas.
       // Tendrá un tamaño de 100x100, y se coloca al lado de la esquina superior derecha de la imagen.
       
       ImageIcon iColor = new ImageIcon("img/tcl2.png");
       //jButton1 = new javax.swing.JButton(Global.LANG.getString("tecla"));
       jButton1 = new javax.swing.JButton (iColor);
       
       
       jButton1.setBounds(5, 5, 100, 40);
       
       jButton1.setFocusable(false);
       jButton1.setFont(Global.INTERFACE_FONT);
       jButton1.addMouseListener(this);
       jButton1.addMouseMotionListener(this);
       
       // jButtonC - Botón que se activa durante la corrección.
       // Tendrá un tamaño de 60x60 y se coloca en la esquina superior derecha del jPanel1.
       jButtonC = new javax.swing.JButton(new ImageIcon("img/rec.png"));
       jButtonC.setBounds(getContentPane().getSize().width/2 - 65, 5,60, 60);
       jButtonC.setFocusable(false);
       jButtonC.setBorder(null);
       jButtonC.setBackground(Color.white);
       jButtonC.addActionListener(new java.awt.event.ActionListener() {
           public void actionPerformed(java.awt.event.ActionEvent evt) {
               isRecording = false;
               if (bBotonesIniciado){
            	   for (int i=0; i<aBotones.length; i++){
            		   if (aBotones[i].isVisible()){  aBotones[i].setEnabled(true);	   }
            	   }
               }
               jMenu1.setEnabled(true);
           	   jMenuC.setEnabled(true);
               jButtonC.setVisible(false);
               jButton1.setVisible(true);
               jlabel2.setVisible(false);
               jPanel1.revalidate();
               repaint();
           }
       	} 
       );
       jButtonC.setVisible(false);
       
       // jPanel1 - Panel donde se encuentra el botón TECLA y el botón Corregir, y dónde se pueden
       // disponer las teclas que cree el usuario. 
       //jPanel1.setPreferredSize(new Dimension (getContentPane().getSize().width/2, 400));
       jPanel1.setBorder(null);
       jPanel1.add(jButton1);
       jPanel1.add(jButtonC);
     
       // jPanelC - Panel donde se muestra la secuencia correcta y demás.
       // Se ubica en el bajo del frame, ocupando todo el ancho y 150 de alto.
       jPanelC = new JPanel();
       jPanelC.setVisible(true);
       jPanelC.setBorder(BorderFactory.createMatteBorder(1, 1, 2, 2, new Color (141,171,202)));
       jPanelC.setPreferredSize(new Dimension (rootPane.getWidth(), 150));
       		jlabel1.setVisible(false);
       		jlabel2.setVisible(false);
       		jlabelsec.setVisible(false);
       jPanelC.setBackground (Color.white);
       jPanelC.add(jlabelsec);
       

      //_---------------------- nuevo

       jPanelContent = new JPanel();
       jPanelContent.setBackground (new Color(205,218,232));//(Color.WHITE);//new Color (246, 227, 206));//new Color (88, 172,250));//new Color (247,248,224));
       jPanelContent.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
       jPanelUp = new JPanel();
       jPanelUp.setSize(getContentPane().getSize().width, getContentPane().getSize().height-190);
       jPanelUp.setPreferredSize(new Dimension (getContentPane().getSize().width, getContentPane().getSize().height-190));
       jPanelUp.setBackground(Color.WHITE);//new Color (189,189,189));
       jPanelUp.setLayout (new GridLayout (1,2));
       
       //jPanelUp.setBorder(BorderFactory.createEmptyBorder(3,3,3,3));
       //jPanelUp.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
       jPanelUp.setBorder(BorderFactory.createMatteBorder(1, 1, 2,2, new Color (141,171,202))); //(141,171,202)));
       
       jPanelImg = new JPanel();
       jPanelImg.setLayout(new BorderLayout());
       
       jPanelImg.setBackground(Color.white);//new Color (46,145,254));
      
       jPanelImg.setBorder(BorderFactory.createEmptyBorder(2,2, 2, 2));
       jPanelImg.add (jBImagen);
       jPanelUp.add (jPanelImg);
       jPanelUp.add (jPanel1);

       jPanelContent.add (jPanelUp, BorderLayout.CENTER);
       jPanelContent.add (jPanelC, BorderLayout.SOUTH);
       
       add (jPanelContent);
       
      // add(jPanel1, BorderLayout.CENTER);
      // add(jPanelC, BorderLayout.SOUTH);
       
   }
   
   private void setjPanel1 (int iw, int ih){
	  
	   int width = iw;
	   int height = ih;
	   jPanelContent = new JPanel();
	   jPanelContent.setPreferredSize (new Dimension(width,height));
	   jPanelContent.setBackground(Color.white);
	   jPanelContent.setLayout(null);
	  
	   jBImagen = new JButton (Global.LANG.getString("imgdesc"));
       jBImagen.setFocusable(false);     
       jBImagen.setBounds(0,0,width/2,height);
       
       jPanel1 = new JPanelCuadricula ();
       jPanel1.setPreferredSize(new Dimension(width/2,height));
       jPanel1.setBounds(width/2 + 1,0, width/2, height );
       
       jPanelContent.add (jBImagen);
       jPanelContent.add(jPanel1);
       add(jPanelContent, BorderLayout.CENTER);
   }
   
   /**
    * Devuelve el panel con la cuadrícula
    * @return Panel con la cuadrícula de botones redimensionada
    */
   public JPanel getCuadricula () {
	   return jPanelContent;
   }
   
    /**
     * @param args the command line arguments
     */
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JFrame jFramePadre;
	private javax.swing.JButton jButton1, jButtonC, jBImagen;
    private javax.swing.JMenu jMenu1, jMenuC, jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1,jMenuItem2,jMenuItem3, jMenuItem4,jMenuItem5, jMenuItem1C,jMenuItem2C;

    // End of variables declaration//GEN-END:variables
    // Mis variables 
    private virtual.JPanelCuadricula jPanel1;
    private javax.swing.JPanel jPanelContent, jPanelUp, jPanelC, jPanelImg;
    private static JButton[] aBotones;
    private int iContador, ordenSecuencia=1,iJP1Width,iJP1Height ;
    private NuevoBoton ventana = null;
    private boolean bHuboDrag = false, bBotonesIniciado=false,isRecording=false;
    private JFileChooser fileChooser = new JFileChooser();
    private JLabel jlabel1 = new JLabel (Global.LANG.getString("nohaysec")), jlabel2 = new JLabel (Global.LANG.getString("grabando")), jlabelsec = new JLabel ("");
    private String[] sSecuencia; // Almacena los textos (tooltiptext) en orden de la secuencia correcta.
    private String sSec; // Almacena los textos para crear la jlabelsec.
    private String sRutaImagen;
    private String sArchivo; //Nombre del archivo abierto. Al principio Nuevo.
    private final Credits acerca = new Credits (Global.LANG.getString("creditTitulo") + Global.VERSION, this, 
			  									Global.FAVICON_TV, Global.FRAME_WIDTH, 
			  									Global.IMG_FOLDER + Global.SEPARADOR_SYS, 
			  									Global.TEMP_FOLDER, "tcv");
    

    public JButton[] getaBotonces(){
    	return aBotones;
	}
    
    
 /****
     *  FUNCI�N MuestraImagenDesc
     *  
     *  @author njerez
     *  *************************************************************************/ 
   private void MuestraImagenDesc (String sFile){
	   System.out.println (sFile);
	   ImageIcon iPicto = new ImageIcon(sFile);
       Image img = iPicto.getImage();               
       Image newimg = img.getScaledInstance(jBImagen.getSize().width, jBImagen.getSize().height, java.awt.Image.SCALE_SMOOTH); 
       ImageIcon newIcon = new ImageIcon(newimg);
       jBImagen.setIcon(newIcon);
       jBImagen.setText(null);
	   
   }
/****
     *  FUNCI�N NuevoTeclado
     *  Realiza los ajustes necesarios para empezar a escribir un nuevo teclado:
     *  - inicializa aBotones, iContador, iSecuencia, sSecuencia, y bBotonesIniciado.
     *  Limpia JPanel1 y reinicia el array de botones y el contador.
     *  @author njerez
     *  *************************************************************************/ 
  private void NuevoTeclado(){
	  if (bBotonesIniciado){
		  for (int i=0; i<aBotones.length; i++){
			  aBotones[i].setVisible(false);
			  aBotones[i].repaint();
		  }
		  jlabelsec.setVisible(false);
		  aBotones = new JButton[0];
		  iContador = 0;
		  bBotonesIniciado = false;
		  jBImagen.setIcon(null);
		  jBImagen.setText(Global.LANG.getString("imgdesc"));
	      jBImagen.setBackground(new Color (251,245,239));//(251,251,239));//Color.white); 
	      jMenu2.setEnabled(true);
	      jMenu2.setText(Global.LANG.getString("nuevotcv"));
	      sArchivo="nuevo.xml";
	      jMenu2.setEnabled(false);
	  }
	  jMenuItem3.setEnabled(false);
  }
  

  /****
   *  FUNCI�N GuardarTeclado
   *  
   *  @author njerez
   *  *************************************************************************/ 
  private void GuardarTeclado(){
	    XMLBotones bt = new XMLBotones();
	  //Ventana de selección de ficheros con filtrado por extensión
	    FileNameExtensionFilter filtro = new FileNameExtensionFilter (Global.LANG.getString("nombreFiltroXML"), "xml");
		
//nio 14 04 2012	
	    
	    File root = new File (Global.TCV2_FOLDER+Global.SEPARADOR_SYS);
	    FileSystemView fsv = new SingleRootFileSystemView (root);
	    fileChooser = new JFileChooser (fsv);
//fin nio 14 04 2012
	    
	    fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		fileChooser.setFileFilter(filtro);
		fileChooser.setSelectedFile(new File(sArchivo));
  		//fileChooser.setCurrentDirectory(new File (Global.TCV2_FOLDER+Global.SEPARADOR_SYS));
  		int seleccion = fileChooser.showSaveDialog(rootPane);
  		if (seleccion == JFileChooser.APPROVE_OPTION)
  		{
  			/*setSecuenciaCompleta(); // trata iSecuencia para que tenga el mismo tama�o que aBotones
  			for (int i=0; i<iSecuencia.length; i++){
  				System.out.println("iSec = "+iSecuencia[i]);
  			}*/
  			//File fichero = fileChooser.getSelectedFile(); toda la ruta
  			String fichero = fileChooser.getSelectedFile().getName();     
  			if (!fichero.endsWith(Global.LANG.getString("extension"))){
  				fichero=fichero+Global.LANG.getString("extension");
  			}
  			// si guarda el archivo, se cambia el nombre.
  			if (bt.newConfigXML(this, Global.TIPO_TCV2, jPanel1.getSize().width, jPanel1.getSize().height, aBotones, fichero, Global.TCV2_FOLDER+Global.SEPARADOR_SYS,sRutaImagen)){
  			// Lo guarda en C:\Users\njerez\workspace\TICA\tcv1\prueba.xml	
  			 jMenu2.setText(Global.LANG.getString("ejercicio")+fichero);
  			}
  		} 
  }
  
  /****
   *  FUNCI�N AbrirTeclado
   *  
   *  @author njerez
   *  *************************************************************************/ 
  private void AbrirTeclado(){
	 
	  NuevoTeclado(); // limpia
	  
	//Ventana de selección de ficheros con filtrado por extensión
      FileNameExtensionFilter filtro = new FileNameExtensionFilter (Global.LANG.getString("nombreFiltroXML"), "xml");
	  fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
	  fileChooser.setFileFilter(filtro);
	  fileChooser.setCurrentDirectory(new File (Global.TCV2_FOLDER+Global.SEPARADOR_SYS));
	  int seleccion = fileChooser.showOpenDialog(rootPane);
	  if (seleccion == JFileChooser.APPROVE_OPTION){
  		MuestraTecladoConf(true, fileChooser.getSelectedFile().getName());	
  		// escribe nombre del ejercicio en la barra
  			jMenu2.setEnabled(true);
  			sArchivo=fileChooser.getSelectedFile().getName();
			jMenu2.setText(Global.LANG.getString("ejercicio")+sArchivo);
			
			jMenu2.setEnabled(false);
			// activa opción de guardar
  			jMenuItem3.setEnabled(true);
  		} 
  }
  
  private void AbrirTeclado(String sname){
	  NuevoTeclado();
	  MuestraTecladoConf (false, sname);
  }

  private void MuestraTecladoConf (boolean bIsConfig, String sname){
	  boolean bisTexto = true;
	  	XMLBotones bt = new XMLBotones();
		//aBotones = bt.readConfigXML(fileChooser.getSelectedFile().getName(), "tcv2");
	  	
	  	aBotones = bt.readConfigXML(sname, Global.TCV2_FOLDER);
		MuestraImagenDesc(Global.TCV2_IMG_FOLDER+Global.SEPARADOR_SYS+bt.getImagen()); 
	    if (aBotones != null){ // si hay Botones, se muestran y se les ponen los listener
	    	for (int i=0; i<aBotones.length; i++){
	    	    if (aBotones[i].getName() != null){
	    	    	bisTexto = false;
	    		}
	    		CambiaTecla(i, bisTexto , aBotones[i].getSize().width, aBotones[i].getSize().height,aBotones[i].getToolTipText(), aBotones[i].getName(), aBotones[i].getBackground(), aBotones[i].getForeground(), aBotones[i].getFont().getSize());
	    		aBotones[i].setVisible(true);
	    		if (bIsConfig){ //Si se está en modo Configuración, se les añaden los listener
	    			aBotones[i].addMouseMotionListener (this);
	    			aBotones[i].addMouseListener (this);
	    		}
	    		
	    		aBotones[i].repaint();
	    		jPanel1.add(aBotones[i]);
	    	}
	    	jPanel1.revalidate();
	    	repaint();
	    	
	    	iJP1Width = bt.getLastKeyboardSize().width;
	    	iJP1Height = bt.getLastKeyboardSize().height;
	    	
	    	bBotonesIniciado = true;
	    	iContador = aBotones.length;
	    }
  }

  
  
  
 /****
     *  FUNCION mouseReleased
     *  Gestiona el evento Drop, de un D&D, dependiendo del componente que lo
     *  desencadena: Si es el bot�n padre creador (JButton1) o en cualquier otro
     *  caso.
     *  Si no fue un drop, simplemente muestra la ventana de configuracion.
     *  @author njerez
     *  *************************************************************************/ 
    public void mouseReleased(MouseEvent e) {

    	// Halla el iD del bot�n que ha invocado el Evento----------------
    	Component component = e.getComponent();
		int iD = 0;
		for (int i = 0; i < iContador; i++) {
			if (component.equals(aBotones[i])) { iD = i;	}
		} 

    	if (isRecording){ // si se estÁ grabando secuencia correcta...
    		if (aBotones[iD].isEnabled()){ // si el bot�n no pertenece ya a la secuencia
    			aBotones[iD].setMnemonic(ordenSecuencia);
    			mostrarSecuencia();
    			ordenSecuencia++;
    		}
    		aBotones[iD].setEnabled(false); // el botón se inutiliza, sólo se puede incluir una vez en la secuencia.
    	}
    	else { // si no se está grabando la secuencia correcta...
    		
    		if (bHuboDrag){ // Si hubo operacion d&d, miramos a ver si fue del Boton Padre o de cualquier otro.
    			bHuboDrag = false;
    			if (e.getComponent() == jButton1){ //if boton padre -> Crea Boton
    				creaBoton(e);
    				jButton1.setBounds(5, 5, jButton1.getWidth() , jButton1.getHeight() );
    			}
    			else { // if otro boton -> Mueve Boton
    				
    				// Si está dentro del panel hago el cambio de Bounds
    	    		if (isInPanel(e,aBotones[iD]) ){
    	    			aBotones[iD].setBounds(e.getX()+e.getComponent().getBounds().x , e.getY()+e.getComponent().getBounds().y , aBotones[iD].getSize().width, aBotones[iD].getSize().height);
    	    			//debug 9 aBotones[iD].setBounds(initX+e.getX()+e.getComponent().getBounds().x , initY+e.getY()+e.getComponent().getBounds().y , aBotones[iD].getSize().width, aBotones[iD].getSize().height);
    	    		}
    	    		else {
    	    			aBotones[iD].setBounds(aBotones[iD].getBounds().x, aBotones[iD].getBounds().y, aBotones[iD].getWidth(), aBotones[iD].getHeight());
    	    		}
    	    		aBotones[iD].setVisible(true);    			}	
    		}
    		// Si fue un simple click, sin D&D, de un bot�n != boton padre -> Muestra el Configurador.
    		// Previamente carga los Valores de Ventana con los datos del Boton que lo ha llamado.
    		else if (e.getComponent() != jButton1){
    			//if ((iSecuencia != null) && (iSecuencia[iD] != 0)){
    			if ((bBotonesIniciado) && (aBotones[iD].getMnemonic() != -1)){	
    				//JOptionPane.showMessageDialog(this, Global.LANG.getString("cuidado"));
    				//niobe
    				Object[] options = {Global.LANG.getString("aceptar")};
    				JOptionPane.showOptionDialog(
                		    this,
                		    Global.LANG.getString("cuidado"),
                		    		Global.LANG.getString("aviso"),
                		    JOptionPane.YES_NO_OPTION,
                		    JOptionPane.WARNING_MESSAGE,
                		    null,     //do not use a custom Icon
                		    options,  //the titles of buttons
                		    options[0]);
    			}
    			ventana.setIdBoton(iD);
    			ventana.setColors(aBotones[iD].getForeground(), aBotones[iD].getBackground());
    			ventana.setValoresVentana (aBotones[iD]);
    			ventana.display(component);	
    		} //else if 
    	} // else
    	
    }

    
 /****
     *  FUNCI�N mouseDragged
     *  Gestiona el evento Drag, de un D&D. Va mostrando el elemento por 
     *  donde se mueva el cursor.
     *  @author njerez
     *  *************************************************************************/ 
    public void mouseDragged(MouseEvent e) {
    	if (!isRecording){ // sólo hace el drag si no se est� grabando la secuencia correcta.
    	
    	bHuboDrag = true;
    	e.getComponent().setVisible(false);
    	
    	if (e.getComponent() != jButton1){
    		Component component = e.getComponent();
    		int iD = 0;
    		for (int i = 0; i < iContador; i++) {
    			if (component.equals(aBotones[i])) {
    				iD = i;
    			}
    		} 
    		// Si está dentro del panel hago el cambio de Bounds
    		if (isInPanel(e,aBotones[iD]) ){
    			
				// Lo redibuja en la nueva posición
				aBotones[iD].setBounds(e.getX()+e.getComponent().getBounds().x, e.getY()+e.getComponent().getBounds().y, aBotones[iD].getWidth(), aBotones[iD].getHeight());
    		}
    		// Si está fuera del panel lo dejo donde estaba.
    		else {
    			aBotones[iD].setBounds (aBotones[iD].getBounds().x ,aBotones[iD].getBounds().y,aBotones[iD].getWidth(), aBotones[iD].getHeight());
    			
    		}
			//debug 9	aBotones[iD].setBounds(initX+e.getX()+e.getComponent().getBounds().x, initY+e.getY()+e.getComponent().getBounds().y, aBotones[iD].getWidth(), aBotones[iD].getHeight());

    		aBotones[iD].setVisible(true);
    	}
    	else {
    		// Si está dentro del panel
    		if (isInPanel(e,jButton1) ){
    			jButton1.setBounds(e.getX()+e.getComponent().getBounds().x, e.getY()+e.getComponent().getBounds().y, jButton1.getWidth(), jButton1.getHeight());
    			
    		}
    		else {
    			jButton1.setBounds(jButton1.getBounds().x,jButton1.getBounds().y, jButton1.getWidth(), jButton1.getHeight());
    		}
    		jButton1.setVisible(true);
    	}
    	
    	}
    }

    public void mouseMoved(MouseEvent e) {    }
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {}
    
 /****
     * FUNCI�N CREABOTON.
     * Utilizando el contador general "iContador" para conocer el n�mero
     * de botones creados hasta el momento, crea un bot�n nuevo y lo a�ade al array
     * de Botones "aBotones", que almacen las teclas. Crea el bot�n con un texto: 
     * Bot�n + id, un tama�o de 100x100, y un evento click que activa la ventana
     * de configuraci�n de tecla.
     *   
     *  @param iX = posici�n X del rat�n, dentro del JPanel1 (dise�o nuevo)
     *  @param iY = posici�n Y del rat�n, dentro del JPanel1 (dise�o nuevo)
     *  @param e = evento del mouse
     *  @author njerez
 **********************************************************************************/
    private void creaBoton(MouseEvent e) {
    	 
   // Crea el boton que corresponda en el Array de Botones 
         if (iContador == 0) {
            aBotones = new JButton[1];
            aBotones[iContador] = new JButton(Global.LANG.getString("boton")+iContador);
            aBotones[iContador].setToolTipText(Global.LANG.getString("boton")+iContador);
       
        } else {
            JButton[] aAuxiliar = new JButton[iContador + 1];
            for (int i = 0; i < iContador; i++) {
                aAuxiliar[i] = aBotones[i];
            }
            aAuxiliar[iContador] = new JButton(Global.LANG.getString("boton")+iContador);
            aAuxiliar[iContador].setToolTipText(Global.LANG.getString("boton")+iContador); 
            aBotones = aAuxiliar.clone();
        }
         aBotones[iContador].setFont(Global.INTERFACE_FONT);
         aBotones[iContador].setMnemonic(-1); // no pertenece a secuencia correcta.
         aBotones[iContador].setBackground(new Color(224,236,248));
         aBotones[iContador].setContentAreaFilled (false);
     	 aBotones[iContador].setOpaque (true);
     	 aBotones[iContador].setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
     
   // Recoge el lugar donde se debe crear el nuevo boton 
         int iBx = e.getComponent().getBounds().x;
         int iBy = e.getComponent().getBounds().y;
               

   // Para poder arrastrar un boton y cambiarlo de lugar
        aBotones[iContador].addMouseMotionListener (this);
        aBotones[iContador].addMouseListener (this);
        
    // Lo coloca en el lugar especificado y con el tamaño 100x100 
        iBx = e.getX()+iBx;
        iBy = e.getY()+iBy;
        if (iBx < 0) { iBx = 0;}
        if (iBy < 0) { iBy = 0;}
        if (iBx > jPanel1.getWidth() - 100) { iBx =jPanel1.getWidth() - 100; }
        if (iBy > jPanel1.getHeight() - 100) { iBy =jPanel1.getHeight() - 40; }
        aBotones[iContador].setBounds(iBx , iBy , 100, 40);
     
        
        //aBotones[iContador].setBounds(e.getX()+iBx , e.getY()+iBy , 100, 40);
              
        jPanel1.add(aBotones[iContador]);
        jPanel1.revalidate();
        repaint();
        bBotonesIniciado = true;
        iContador++;
        jMenuItem3.setEnabled(true);

    } // Fin creaBoton

    
    // Para hacer modal la ventana de Configuracion VentanaTitulo, utilizo estos 
    // metodos del listener de window.
    public void windowOpened(WindowEvent e) {setEnabled(false);}
    public void windowClosing(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {setVisible(true);}
    public void windowDeiconified(WindowEvent e) {} 
    public void windowClosed(WindowEvent e) {
    	int iD = ventana.getIdBoton(), iAncho = ventana.getAncho(), iLargo = ventana.getLargo(), iFuente = ventana.getFuente();
    	String sTexto = ventana.getTexto(), sPictoSelec = aBotones[iD].getName();
    	boolean isTexto = ventana.isTexto();
    	Color cTexto = ventana.getColorTexto(), cBack = ventana.getColorBack(); 	 
    	if (ventana.isSuprimed()){ BorraTecla (iD);}
    	setEnabled(true);
    	sPictoSelec = ventana.getPictoId (sPictoSelec);
		CambiaTecla(iD, isTexto, iAncho, iLargo, sTexto, sPictoSelec, cBack, cTexto, iFuente);
    	setVisible(true);
    }
    
    public void windowActivated(WindowEvent e) {setEnabled(false);}
    
    public void windowDeactivated(WindowEvent e) {
    	setVisible(true);
    }

 /****
     * FUNCI�N BORRATECLA
     * (Borra la tecla del panel) la pone invisible e inaccesible.
     *  @param idBoton = posicion del Boton en el array de botones aBotones
     *  @author njerez
 **********************************************************************************/
    private void BorraTecla(int idBoton){
    	// si es un botón de la secuencia correcta no se puede borrar.
    	if (aBotones[idBoton].getMnemonic() != -1) {
    		JOptionPane.showMessageDialog(this, Global.LANG.getString("nopuede"));
    	}
    	else {
    		jMenuItem3.setEnabled(false); // no se permite el 'guardado'
    		
    		for (int i=0; i<aBotones.length; i++){
    			// boton a eliminar
    			if (i == idBoton) {
    				aBotones[i].setEnabled(false);
    				aBotones[i].setVisible(false);
    				aBotones[i].repaint();
    			} 
    			// si hay algún botón visible se permite guardar
    			if (aBotones[i].isVisible()){
    				jMenuItem3.setEnabled(true);
    			}
    		}
    	}
    }
    
    
 /****
     * FUNCI�N CAMBIATECLA.
     * Utilizando los datos recogidos antes de cerrar la ventana de 
     * Configuracion de la tecla cambia el aspecto de la tecla.
     * En el atributo Name, del jButton se almacenara el nombre de la imagen
     * si es tipo pictograma. Si es tipo texto, se asignara name = null
     * 
     *  @param idBoton = posicion del Boton en el array de botones aBotones
     *  @param btipotexto = tipo boolean, sera true si la tecla es tipo texto
     *                                    sera false si es tipo pictograma
     *  @param iancho = ancho a aplicar a la tecla
     *  @param ilargo = largo a aplicar a la tecla
     *  @param stexto = texto a asociar a una tecla tipo texto
     *  @param picto = string con el nombre de la imagen, sin ruta y sin extensi�n
     *  @param colorBack = color para el fondo de la tecla
     *  @param colorTexto = color para el color de la fuente
     *  @param ifuente = integer con el tamaño para la fuente
     *  @author njerez
 **********************************************************************************/
    private void CambiaTecla(int idBoton, boolean btipotexto, int iancho, int ilargo, String stexto, String picto, Color colorBack, Color colorTexto, int ifuente) {
    	
    	if ((iancho < 0) | (iancho > 600)) { iancho = 100;}
        if ((ilargo < 0) | (ilargo > 600)) { ilargo = 100;}
        aBotones[idBoton].setSize(iancho, ilargo);      
    	aBotones[idBoton].setText(stexto);
    	aBotones[idBoton].setContentAreaFilled (false);
    	aBotones[idBoton].setOpaque (true);
        aBotones[idBoton].setBackground(colorBack);
        aBotones[idBoton].setToolTipText(stexto);
        aBotones[idBoton].setForeground(colorTexto);
        aBotones[idBoton].setMargin(new Insets(0, 0, 0, 0));
        aBotones[idBoton].setFocusable(false);
        Font mifuente = new Font("sansserif", Font.PLAIN, ifuente);
        aBotones[idBoton].setFont(mifuente);
        aBotones[idBoton].setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
                
        if (!btipotexto) { 
        	// Si la tecla es de tipo pictograma
        	if (picto != null){  // y si existe pictograma seleccionado
            String ruta = Global.PICT_FOLDER+Global.SEPARADOR_SYS;
            ruta = ruta.concat(picto);
            ruta = ruta.concat(Global.PICT_EXT_PUNTO);
            ImageIcon iPicto = new ImageIcon(ruta);
            Image img = iPicto.getImage();               
            Image newimg = img.getScaledInstance(iancho, ilargo, java.awt.Image.SCALE_SMOOTH); 
            ImageIcon newIcon = new ImageIcon(newimg);
            aBotones[idBoton].setIcon(newIcon);
            aBotones[idBoton].setText("");
            aBotones[idBoton].setToolTipText(stexto); // El texto se guarda en el tooltip para que no afecta a la imagen
            aBotones[idBoton].setName(picto);
            aBotones[idBoton].setBackground(Color.WHITE);
        	}
        } else { 
        // Si la tecla es de tipo texto o no hay pictograma seleccionado.
        	aBotones[idBoton].setIcon(null);
        	aBotones[idBoton].setName(null);
        }
                
        aBotones[idBoton].repaint();

    }
    
    /****
     *  FUNCI�N isInPanel
     *  Controla si el cursor se encuentra del jPanel1 (Cuadrícula).
     *  Devuelve true si está dentro, false en otro caso.
     *  @author njerez
     *  *************************************************************************/ 
    public boolean isInPanel (MouseEvent e, JButton b){
    	if ((e.getX()+e.getComponent().getBounds().x > 0)
				&&(e.getY()+e.getComponent().getBounds().y >0)
				 && ( (e.getX()+e.getComponent().getBounds().x+b.getWidth()) < jPanel1.getWidth() )
				  && ( (e.getY()+e.getComponent().getBounds().y+b.getHeight()) < jPanel1.getHeight() )
		){
    		return true;
    	}else{
    		return false;
    	}
    
    }
}